# $Id: updatesupport.py,v 1.1.1.1 2001/04/26 18:08:05 chrisw Exp $

from zLOG import LOG, INFO
import sys,traceback
import string

logtext = ''
log=''

def _log(thestring,comment):
    global log
    thestring = thestring + string.replace(comment,'\n','<BR>\n') + '<BR>\n'
    log = "%s%s\n" % (log,comment)
    return thestring
    
def _flushlog():
    global logtext
    global log
    LOG(logtext,INFO,'Update:',log)
    log=''

def _updateall(self,updatemethod, metatypes=[]):
    global logtext
    logtext = string.join(metatypes,', ')
    return_text=''
    objects = self.ZopeFind(self,obj_metatypes=metatypes, search_sub=1)
    for (id,object) in objects:
        return_text = _log(return_text,"Processing '%s'" % id)
        try:
            return_text = return_text + updatemethod(object)
        except:
            type,value,tb = sys.exc_info()
            return_text = _log(return_text,
                               "An error occurred when processing '%s'\nType:%s\nValue:%s\n" % (id,
                                                                                                type,
                                                                                                value,))
            traceback.print_tb(tb)
        _flushlog()
    return '<HTML><BODY>\n' + return_text + '\n</BODY></HTML>'
            


